From 719efa2156a8d830218007e98922d0ec53437d13 Mon Sep 17 00:00:00 2001
From: Hari Babu <kommi.haribabu@gmail.com>
Date: Wed, 21 Nov 2018 10:19:20 +1100
Subject: [PATCH] jsonb_populate_recordset crash fix

Accessing of NULL data while forming the record
leads to crash. As per bug #15541
---
 src/backend/utils/adt/jsonfuncs.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/src/backend/utils/adt/jsonfuncs.c b/src/backend/utils/adt/jsonfuncs.c
index 0d3e1121cd..7a55c1847d 100644
--- a/src/backend/utils/adt/jsonfuncs.c
+++ b/src/backend/utils/adt/jsonfuncs.c
@@ -3739,7 +3739,8 @@ populate_recordset_worker(FunctionCallInfo fcinfo, const char *funcname,
 	 * we're called again in the same query.
 	 */
 	rsi->setResult = state->tuple_store;
-	rsi->setDesc = CreateTupleDescCopy(cache->c.io.composite.tupdesc);
+	if (cache->c.io.composite.tupdesc)
+		rsi->setDesc = CreateTupleDescCopy(cache->c.io.composite.tupdesc);
 
 	PG_RETURN_NULL();
 }
-- 
2.18.0.windows.1

